#!/usr/local/bin/perl

require 'init.cgi';

#======================================================
#inobbs ver.2.0, (C)Copyright ino
# このソフトウェア（以下「inobbs」と記述）はinoが作成しました。
#
# inobbsはフリーソフトです。
# inobbsを使用して発生したいかなる損害に対しても作者は責任を負いません。
#======================================================

##########メイン##########
$CHARSET  = 'UTF-8';
#$conv='sjis';

loadData();
# 記事データの読み込み
open(FILE, "<$DATAFILE") or errorPage("$DATAFILEが開けません。");
eval{ flock(FILE, 1) };
@DATA = <FILE>;
close FILE;

printPage();
exit;


########## 記事ページの出力 ##########
sub	printPage
{
	my	$begin = $FORM{'page'} * $PAGEVIEW;
	my	$end   = $begin + $PAGEVIEW;
	
	if($end > @DATA) {
		$end = @DATA;
	}
	
print <<END;
Content-type: text/html; charset=$CHARSET

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=$CHARSET" />
<link rel="stylesheet" href="$CSSFILE" type="text/css" />
<title>inobbs</title>
<script language="javascript" type="text/javascript">
function OpenForm (c) {
    window.open(c,
     'comments',
     'width=200,height=220,scrollbars=yes,status=yes');
}
</script>
</head>
<body>
<div $CSS{'bbsbody'}>
END
	
my	($i, $nextpage, $len_url, $len_author);
	
	
	# 記事の出力
	for($i = $begin ; $i < $end ; ++$i) {
		print qq(<div $CSS{'bbscontent'}>);
		my	($date, $title, $author, $url, $text) = split(/\t/, $DATA[$i]);
		
		$len_author = length($author); 
		if($len_author < 1){ $author=$UNKNOWN; }
		
		convert2url($text,$url);
		
		if($FLAG_SMILE){ repSmileTag($text); repSmileTag($author); }
		
		print qq($text\n);
		
		$len_url = length($url);
		if($url=~/mailto/i or $url=~/http:\/\//i and $len_url>7) { 
			if($SHOW_HPMAIL){
				if($url=~/mailto/i){ $hpmail="<$url>$MAIL_MARK</a>";}
				else{$hpmail="<$url>$HP_MARK</a>";}
				$author="<$url>$author</a> $hpmail";
			}else{
				$author="<$url>$author</a>";
			}
		}
		
		if($SHOW_AUTHOR || $SHOW_DATE){
			if($SHOW_AUTHOR){ $author=qq(by $author );}else{$author="";}
			if($SHOW_DATE){ $date=qq(at $date);}else{$date="";}
			print qq(<div $CSS{'bbsdate'}>$author$date</div>);
		}
		
		print qq(</div>\n);
	}
	
	# 次ページへのリンク
	print qq(<div $CSS{'bbsfooter'}>);
	if($end < @DATA) {
		$nextpage = $FORM{'page'} + 1;
		print qq(<a href="$ENV{'SCRIPT_NAME'}?page=$nextpage">&laquo;prev</a>\n);
	}
	
	if($FORM{'page'}>0  &&  $end <= @DATA) {
		$nextpage = $FORM{'page'} - 1;
		print qq(&nbsp;<a href="$ENV{'SCRIPT_NAME'}?page=$nextpage">next&raquo;</a>\n);
	}
	
	
		if($COPYRIGHT){ print qq(<br /><a href="$myaddress" target="_blank">inobbs ver.$version</a>\n); }
		else{ print qq(<br /><div style="display: none">inobbs ver.$version ( $myaddress )</div>\n); }
		print qq(</div>\n);
		
print <<END;
  </div>
</body>
</html>
END
}

########## エラーページ出力 ##########
sub	errorPage
{
print <<END;
Content-type: text/html; charset=$CHARSET

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=$CHARSET" />	
<link rel="stylesheet" href="$CSSFILE" type="text/css" />	
<title>inobbs</title>
</head>
<body><div $CSS{'bbsbody'}><div $CSS{'bbscontent'}>エラー<br />$_[0]</div></div></body>
</html>
END
	exit;
}
########## アドレス変換 ##########
sub convert2url
{
		foreach ($_[0]) { #foreach ($text) {
			#&jcode::convert(\$_,'euc');
			s/(http:\/\/[\w\.\~\-\/\?\&\+\=\:\@\%\;\,]+)
			/<a href=\"$1\" target=\"_blank\">$LINK_MARK<\/a>/giox;
			s/([\w\.\-\_]+)\@([\w\.\-\_]+)
			/<a href=\"mailto\:$1\@$2\">$MAIL_MARK<\/a>/giox;
			#&jcode::convert(\$_,$conv);
		}
	
		foreach ($_[1]) { #foreach ($url) {
			#&jcode::convert(\$_,'euc');
			s/(http:\/\/[\w\.\~\-\/\?\&\+\=\:\@\%\;\,]+)
			/a href=\"$1\" target=\"_blank\"/giox;
			s/([\w\.\-\_]+)\@([\w\.\-\_]+)
			/a href=\"mailto\:$1\@$2\"/giox;
			#&jcode::convert(\$_,$conv);
		}
}

##########フォームデータ取り込み ##########
sub	loadData
{
	my	($query, $pair);
	
	if($ENV{'REQUEST_METHOD'} eq 'POST') {
		read(STDIN, $query, $ENV{'CONTENT_LENGTH'});
	}
	else {
		$query = $ENV{'QUERY_STRING'};
	}
	
	foreach $pair (split(/&/, $query)) {
		my	($key, $value) = split(/=/, $pair);
		
		$value =~ tr/+/ /;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
		
		#&jcode::convert(\$value,$conv);
		$value =~ s/\s+$//;
		$value =~ s/&/&amp;/g;
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
		$value =~ s/\x0D\x0A/<br \/>/g;
		$value =~ tr/\t/ /;
		$value =~ s/\'/&#39;/g;
		
		$FORM{$key} = $value;
	}
}

########## スマイリータグ ##########
sub repSmileTag
{
	my $WIDTH=15,$HEIGHT=15;   ###スマイリー画像のサイズはここを変更
	my $i;
	for($i = 0 ; $i < $SMILENUM ; ++$i) {
		$_[0] =~ s/\(:$SMILETAG[$i]:\)/<img src=\"$SMILEIMG[$i]\" width=\"$WIDTH\" height=\"$HEIGHT\" border=\"0\" alt=\"(:$SMILETAG[$i]:)\" \/>/g;
	}
}